import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;


public class ProcessData {

	private static HashMap<Double, Integer> qualityToNumOfPackets = new HashMap<Double, Integer>();
	
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		

		int replicationNumber = 5; 
		List<String> file= readFile("C:\\Users\\shuna\\Documents\\Master measurements\\The shit\\Sumo\\10MLimit\\0.05 PL\\tv2Regular10MLimit005PLR"+replicationNumber);
		//List<String> file= readFile("C:\\Users\\shuna\\Documents\\Master measurements\\The shit\\Comoyo\\10MLimit\\0.05 PL\\veum10MLimit005PLR"+replicationNumber);
		String outputFilePath = "C:\\Users\\shuna\\Dropbox\\Master\\Mathematica\\The shit\\Sumo\\10MLimit\\0.05 PL\\";
		
		double PLintro = 30.0;
		
		//antar nyttedata per pakke: 1460 bytes
		
		qualityToNumOfPackets.put(0.25, 42);
		qualityToNumOfPackets.put(0.35, 60);
		qualityToNumOfPackets.put(0.5, 86);
		qualityToNumOfPackets.put(0.75, 128);
		qualityToNumOfPackets.put(1.0, 171);
		qualityToNumOfPackets.put(1.5, 256);
		qualityToNumOfPackets.put(2.5, 428);
		qualityToNumOfPackets.put(3.5, 600);
		qualityToNumOfPackets.put(5.0, 856);
		
		//comoyo
		qualityToNumOfPackets.put(0.097, 17);
		qualityToNumOfPackets.put(0.197, 34);
		qualityToNumOfPackets.put(0.295, 51);
		qualityToNumOfPackets.put(0.493, 84);
		qualityToNumOfPackets.put(0.79, 135);
		qualityToNumOfPackets.put(1.177, 202);
		qualityToNumOfPackets.put(1.578, 270);
		qualityToNumOfPackets.put(2.178, 373);
		qualityToNumOfPackets.put(3.959, 678);
		qualityToNumOfPackets.put(5.934, 1016);
		
		System.out.println(file.get(1));

		List<ArrayList<Object>> list = process(file);
////		
//////		//{unaltGETtime, qualityLevel}
//		createFile(list.get(6), list.get(5), replicationNumber, outputFilePath);
////////////		//{GETtime, segmentThroughput}
//		createFile2(list.get(0), list.get(3), replicationNumber, outputFilePath);
////////////		//{unaltGETtime, accumulatedNumberOfReceivedPackets}
//		createFile3(list.get(6), list.get(7), replicationNumber, outputFilePath);
////////////		//{unaltGETtime}
//		createFile4(list.get(6), replicationNumber, outputFilePath);
//////////		//{numTcpPacketsPerSegment}
//		createFile5(list.get(13), replicationNumber, outputFilePath);
////////		summary, including: {numQualityVariations, Perceived Fairness, AvgRequestedBitrate}
//		createFile7(list.get(5), list.get(6), PLintro, replicationNumber, outputFilePath);
		//{segment Duration} -brukes til  beskrive i No Loss scenarioet
//		createFile8(list.get(11), replicationNumber, outputFilePath);
//      {numPL, segDur} in no loss scenraio with bw limitation
//		createFile10(list.get(11), list.get(12), replicationNumber, outputFilePath);
//		{segThroughput}
//		createFile11(list.get(3), replicationNumber, outputFilePath);
		
		
		
		
		
		//afterProcessing, for analyzing the data before quality degradation and after PL introduction
		//finding qualityDegradationTime
		double qualityDegradationTime = 0.0;
		
		ArrayList<Object> timeGETunaltered = list.get(6);
		ArrayList<Object> qualityLevelunaltered = list.get(5);
		
		for(int i =0; i < qualityLevelunaltered.size()-1; i++){
			double qualityLevel1 = Double.parseDouble(qualityLevelunaltered.get(i).toString());
			double qualityLevel2 = Double.parseDouble(qualityLevelunaltered.get(i+1).toString());
			if(qualityLevel1!=qualityLevel2){
				qualityDegradationTime = Double.parseDouble(timeGETunaltered.get(i+1).toString());
				break;
			}
		}
		
		ArrayList<Object> segDurFull = list.get(11);
		ArrayList<Object> throughputFull = list.get(3);
		ArrayList<Object> numTCPpacketsInSegFull = list.get(13);
		ArrayList<Object> numRetransInSegFull = list.get(12);
		ArrayList<Object> timeGETFull = list.get(0);
		ArrayList<Object> qualityLevelFull = list.get(2) ;
		ArrayList<Object> timeSegReceivedFull = list.get(1);
		ArrayList<Object> timeGETnoAlterFull = list.get(6);
		
		ArrayList<Object> segDur = new ArrayList<Object>();
		ArrayList<Object> throughput = new ArrayList<Object>();
		ArrayList<Object> numTCPpacketsInSeg = new ArrayList<Object>();
		ArrayList<Object> numRetransInSeg = new ArrayList<Object>();
		ArrayList<Object> timeGET = new ArrayList<Object>();
		ArrayList<Object> qualityLevel = new ArrayList<Object>();
		ArrayList<Object> timeSegReceived = new ArrayList<Object>();
		ArrayList<Object> timeGETnoAlter = new ArrayList<Object>();
		
		ArrayList<Object> numTCPpacketsInSegFrom30s = new ArrayList<Object>();
		ArrayList<Object> numRetransInSegFrom30s = new ArrayList<Object>();
		ArrayList<Object> throughputFrom30s = new ArrayList<Object>();
		
		for(int i = 0; i < timeGETFull.size(); i++){
			double time = Double.parseDouble(timeGETFull.get(i).toString());
			if(PLintro<time&&time<qualityDegradationTime){
				segDur.add(segDurFull.get(i));
				throughput.add(throughputFull.get(i));
				numTCPpacketsInSeg.add(numTCPpacketsInSegFull.get(i));
				numRetransInSeg.add(numRetransInSegFull.get(i));
				timeGET.add(timeGETFull.get(i));
				qualityLevel.add(qualityLevelFull.get(i));
				timeSegReceived.add(timeSegReceivedFull.get(i));
			}
			if(PLintro<time){
				numTCPpacketsInSegFrom30s.add(numTCPpacketsInSegFull.get(i));
				numRetransInSegFrom30s.add(numRetransInSegFull.get(i));
				throughputFrom30s.add(throughputFull.get(i));
			}
		}
		for(int i = 0; i < timeGETnoAlterFull.size(); i++){
			double time = Double.parseDouble(timeGETnoAlterFull.get(i).toString());
			if(PLintro<time&&time<qualityDegradationTime){
				timeGETnoAlter.add(timeGETnoAlterFull.get(i));
			}
		}
		//{segDuration} -for analysis of segdur in highest qualityLevel with PL, but before quality degradation
//		createFile8(segDur, replicationNumber, outputFilePath);
//		//{segDur, numPacketLost, timeGET} -after PLintro, before quality degradation
//		createFile9(segDur, numRetransInSeg, timeGET, replicationNumber, outputFilePath);
//		//{numPacketLost, goodput}
//		createFile12(numRetransInSeg, throughput, replicationNumber, outputFilePath);
//		//{timeGET, numPacketLost, segDur, throughput, tcpPacketsInSeg}
////		createFile13(timeGET, numRetransInSeg, segDur, throughput, numTCPpacketsInSeg, replicationNumber, outputFilePath);
//		//{NumRetransInSeg/PL}
	//	createFile14(numRetransInSeg, replicationNumber, outputFilePath);
//		//{numTCPpacketsInSeg}
		//createFile15(numTCPpacketsInSeg, replicationNumber, outputFilePath);
//		//{timeGET}
//		createFile16(timeGET, replicationNumber, outputFilePath);
		//{throughput} after PL intro, before quality deg
		createFile21(throughput, replicationNumber, outputFilePath);
		
		
//		 also sending the timeGETnoAlter to adjust buffLevel for "wrong segments" (no 200 ok registered, for instance)
//		ArrayList<Double> bufferstats = findBufferStatus(timeGET, qualityDegradationTime, timeGETnoAlter);
////		//{TimeGET, bufferstatus} -estimating buffersize-variation,
//		createFile17(timeGETnoAlter, qualityDegradationTime, bufferstats, replicationNumber, outputFilePath);
////		//{totalTCPafterPLintro, totalRatranSegsAfterPLintro} -PLratio
//		createFile18(numTCPpacketsInSegFrom30s, numRetransInSegFrom30s, replicationNumber, outputFilePath);
		//{throughputInSegsFrom 30s}
//		createFile19(throughputFrom30s, replicationNumber, outputFilePath);
     	//{PLratio, throughput} -after PL intro
//		createFile20(numTCPpacketsInSegFrom30s, numRetransInSegFrom30s, throughputFrom30s, replicationNumber, outputFilePath);

////		System.out.println("qualitylevel.size: "+qualityLevel.size()+" last: "+ qualityLevel.get(qualityLevel.size()-1));
////		System.out.println("segdur.size(): "+segDur.size()+" last: "+segDur.get(segDur.size()-1));
////		System.out.println("qualityDegradationTime: "+qualityDegradationTime);
//		for(int i = 0; i < timeGET.size(); i++){
//			System.out.println("timeGet"+i+": "+timeGET.get(i));
//			System.out.println("qualityLevel"+i+": "+qualityLevel.get(i));
//			System.out.println("segDur"+i+": "+segDur.get(i));
//			System.out.println("throughput"+i+": "+throughput.get(i));
//			System.out.println("retranspackets"+i+": "+numRetransInSeg.get(i));
//			System.out.println("numTCPpacketsinSeg"+i+": "+numTCPpacketsInSeg.get(i));
//			System.out.println("timeSegReceived"+i+": "+timeSegReceived.get(i));
//			System.out.println("--------------------------------------------------------");
//		}
//		double packetsLost =0;
//		double totalPackets =0;
//		for(int i = 0; i < numRetransInSeg.size(); i++){
//			packetsLost+= Double.parseDouble(numRetransInSeg.get(i).toString());
//			totalPackets+= Double.parseDouble(numTCPpacketsInSeg.get(i).toString());
//		}
//		System.out.println("packetsLost: "+packetsLost);
//		System.out.println("totalPackets: "+totalPackets);
//		System.out.println("LossRatio: "+packetsLost/totalPackets);
//		System.out.println("-------------------Total---------------");
//		double totalpacketsLost =0;
//		double totaltotalPackets =0;
//		for(int i = 0; i < numRetransInSegFrom30s.size(); i++){
//			totalpacketsLost+= Double.parseDouble(numRetransInSegFrom30s.get(i).toString());
//			totaltotalPackets+= Double.parseDouble(numTCPpacketsInSegFrom30s.get(i).toString());
//		}
//		System.out.println("totalpacketsLost: "+totalpacketsLost);
//		System.out.println("totaltotalPackets: "+totaltotalPackets);
//		System.out.println("totalLossRatio: "+totalpacketsLost/totaltotalPackets);
//		ArrayList<Object> timeRetransmit = new ArrayList<Object>();
//		ArrayList<Object> quality = new ArrayList<Object>();
//		for(int i=0; i<list.get(9).size(); i++){
//			if((Double)list.get(9).get(i)<qualityDegradationTime){
//				timeRetransmit.add(list.get(9).get(i));
//				quality.add(list.get(10).get(i));
//			}
//		}
//		System.out.println(timeRetransmit.size());
//		System.out.println(quality.size());
//		//{timeForPacketRetransmit, qualityLevel}
//		createFile6(timeRetransmit, quality, replicationNumber, outputFilePath);

		
	}

	
	
	
	

	private static ArrayList<Double> findBufferStatus(ArrayList<Object> timeGET, double qualityDegradationTime, ArrayList<Object> timeGETnoAlter) {
		
		ArrayList<Double> buffS = new ArrayList<Double>();
		double bufferlength = 10.0;
		buffS.add(bufferlength);
		double segSize = 2.0;
		
		for(int i = 0; i < timeGETnoAlter.size()-1; i++){
			Double tGETii = Double.parseDouble(timeGETnoAlter.get(i+1).toString());
			Double tGETi = Double.parseDouble(timeGETnoAlter.get(i).toString());
			double deltaTimeGET = tGETii - tGETi;

			bufferlength = bufferlength+(segSize-deltaTimeGET);

			buffS.add(bufferlength);
			
		}
		
		double dTime = qualityDegradationTime-Double.parseDouble(timeGET.get(timeGET.size()-1).toString());
		buffS.add(bufferlength +(segSize-dTime));
		
		for(int i = 0; i < timeGETnoAlter.size(); i++){
			System.out.println("timeGETnoAlter: "+ timeGETnoAlter.get(i));
		}
		for(int i = 0; i < buffS.size(); i++){
			System.out.println("bufflength: "+ buffS.get(i));
		}
		
		return buffS;
		
		
//
//		
//		ArrayList<Double> buffS = new ArrayList<Double>();
//		double bufferlength = 10.0;
//		buffS.add(bufferlength);
//		double segSize = 2.0;
//		
//		ArrayList<Double> GETreqFor2sToBeAdded = new ArrayList<Double>();
//		
//		//if getNoAlter is bigger than timeGET, than the buffer has to be adjusted for missing 2s segments...
//		if(timeGETnoAlter.size()!=timeGET.size()){
//			for(int i = 0; i < timeGETnoAlter.size(); i++){
//				boolean isInList = false;
//				double timeGETunAlt = Double.parseDouble(timeGETnoAlter.get(i).toString());
//				for(int j = 0; j< timeGET.size(); j++){
//					double timeGETelem = Double.parseDouble(timeGET.get(j).toString());
//					if(timeGETunAlt==timeGETelem){
//						isInList= true;
//						break;
//					}
//				}
//				if(!isInList){
//					int index = 0;
//					for(int j = 0; j<timeGET.size();j++){
//						index = j;
//						double tGET = Double.parseDouble(timeGET.get(j).toString());
//						if(timeGETunAlt<tGET){
//							GETreqFor2sToBeAdded.add(tGET);
//							break;
//						}
//					}
//				}	
//			}
//		}
//		
//		
//		
//		for(int i = 0; i < timeGETnoAlter.size(); i++){
//			System.out.println("timeGETnoAlter"+timeGETnoAlter.get(i));
//		}
//		
//		for(int i = 0; i < timeGET.size(); i++){
//			System.out.println("timeGET"+timeGET.get(i));
//		}
//		
//		
//		
//		
//		for(int i = 0; i < timeGET.size()-1; i++){
//			Double tGETii = Double.parseDouble(timeGET.get(i+1).toString());
//			Double tGETi = Double.parseDouble(timeGET.get(i).toString());
//			double deltaTimeGET = tGETii - tGETi;
//			
//			double toBeAdded = 0.0;
//			for(int j = 0; j < GETreqFor2sToBeAdded.size(); j++){
//				double t = GETreqFor2sToBeAdded.get(j);
//				if(t==tGETii){
//					toBeAdded += 2.0;
//				}
//			}
//			bufferlength = bufferlength+(segSize-deltaTimeGET) + toBeAdded;
//			buffS.add(bufferlength+(segSize-deltaTimeGET));
//			
//		}
//		
//		double dTime = qualityDegradationTime-Double.parseDouble(timeGET.get(timeGET.size()-1).toString());
//		buffS.add(bufferlength +(segSize-dTime));
//		
//		
//		for(int i =0; i< buffS.size(); i++ ){
//			System.out.println("BufferStatus: "+buffS.get(i));
//		}
//		
//		return buffS;
	}






	//Returns a list:
	//[0]- ArrayList<Object> timeGet
	//[1]- ArrayList<Object> timeSegReceived
	//[2]- ArrayList<Object> qualityLevel
	//[3]- ArrayList<Object> segmentThroughput
	//[4]- ArrayList<Object> accumulated number of received packets
	//[5]- ArrayList<Object> requested qualityLevels, unaltered
	//[6]- ArrayList<Object> unaltered timeGET
	//[7]- ArrayList<Object> accumulated number of received packets including dummy default values
	//[8]- ArrayList<Object> number of tcp-packets in 2s-segment
	//[9]- ArrayList<Object> time for retransmitted packets
	//[10]- ArrayList<Object> qualityLevel for retransmitted packets
	//[11]- ArrayList<Object> segmentDuration
	//[12]- ArrayList<Object> number of retransmitted packets for each segment
	//[13]- ArrayList<Object> number of TCP packets in each segment
	private static List<ArrayList<Object>> process(List<String> inputFile) {
		inputFile.remove(0);
		
		ArrayList<Object> timeGET = new ArrayList<Object>();
		
		ArrayList<Integer> getRequestIndex = new ArrayList<Integer>();
		ArrayList<Object> timeSegReceived = new ArrayList<Object>();
		ArrayList<Object> requestedQualityLevel = new ArrayList<Object>();
		
		ArrayList<Object> numTcpPackets = new ArrayList<Object>();
		
		ArrayList<Object> timeForRetransmittedPackets = new ArrayList<Object>();
		ArrayList<Object> qualityLevelForRetransmittedPackets = new ArrayList<Object>();
		
		int numberOfGETRequestsWithNoCorresponding200OK = 0;
		
		//in sync with timeGet, segmentRelatedInfo
		ArrayList<Object> segmentThroughput = new ArrayList<Object>();
		ArrayList<Object> numberOfRetransmittedPacketsForSegment = new ArrayList<Object>();
		ArrayList<Object> segmentDuration = new ArrayList<Object>();
		ArrayList<Object> numberOfTCPpacketsInSegment = new ArrayList<Object>();
		
		
		
		
		//ArrayList<Object> seg2sThroughput = new ArrayList<Object>();
		//akkumulert ant pakker:
		ArrayList<Object> accumulatedNumTCPpacketsReceived = new ArrayList<Object>();
		ArrayList<Object> numTCPpacketsReceivedWithDefaultValues = new ArrayList<Object>();
		
		for(int i =0; i< inputFile.size(); i++){
			String [] fields = inputFile.get(i).split(",");
			if(fields[6].contains("video=")){
				timeGET.add(fields[1].substring(1, fields[1].length()-2));
				requestedQualityLevel.add(findQualityLevel(fields[6]));
				System.out.println("Req. quality level "+requestedQualityLevel.get(0));
				getRequestIndex.add(i);				
			}
		}
		ArrayList<Object> timeGETNotToAlter = new ArrayList<Object>();
		ArrayList<Object> qualityLevelNotAltered = new ArrayList<Object>();
		qualityLevelNotAltered.addAll(requestedQualityLevel);
		timeGETNotToAlter.addAll(timeGET);

		
		//til og med nest siste get-request da overfringen av siste segement mest sanns er avbrutt
		for(int i=0; i< getRequestIndex.size()-1; i++){
			int getRequest = getRequestIndex.get(i);
			int nextGetRequest = getRequestIndex.get(i+1);
			
			
			String getRequestString = inputFile.get(getRequest);
			String [] getReqRow = getRequestString.split(",");
			double timeForGETrequest = Double.parseDouble(getReqRow[1].substring(1, getReqRow[1].length()-1));
			
			List<String> sublistBtwGetRequest = inputFile.subList(getRequest, nextGetRequest);
			String[] row = sublistBtwGetRequest.get(0).split(",");
			String clientSrcPort = row[7];
			int indexOfTimeCompletedVideoSegmentTransmission = findHTTP200OK(sublistBtwGetRequest, clientSrcPort);
			//fjern sppelData
			Object qL = requestedQualityLevel.get(timeSegReceived.size());
			if(indexOfTimeCompletedVideoSegmentTransmission == 0){
				numberOfGETRequestsWithNoCorresponding200OK = numberOfGETRequestsWithNoCorresponding200OK+1;
				
				timeGET.remove(timeSegReceived.size());
				qL = requestedQualityLevel.remove(timeSegReceived.size());
				
				//insert default values to numberofTCP-packets received
				//System.out.println("qualityToNumOfPackets.get(Double.parseDouble(qL.toString())):  "+ qualityToNumOfPackets.get(Double.parseDouble(qL.toString())));
				if(numTCPpacketsReceivedWithDefaultValues.size()>0){
					int val = Integer.parseInt(numTCPpacketsReceivedWithDefaultValues.get(numTCPpacketsReceivedWithDefaultValues.size()-1).toString());
					val+= qualityToNumOfPackets.get(Double.parseDouble(qL.toString()));
					numTCPpacketsReceivedWithDefaultValues.add(val);
				}else{
					numTCPpacketsReceivedWithDefaultValues.add(qualityToNumOfPackets.get(Double.parseDouble(qL.toString())));
				}
				
				
				//timeGET.remove(timeGET.size()-1);
				//qualityLevel.remove(qualityLevel.size()-1);
			}else{
				System.out.println("200OK?: "+sublistBtwGetRequest.get(indexOfTimeCompletedVideoSegmentTransmission));
				String [] s = sublistBtwGetRequest.get(indexOfTimeCompletedVideoSegmentTransmission).split(",");
				String HTTP200OKtime = s[1].substring(1, s[1].length()-1);
				timeSegReceived.add(HTTP200OKtime); 				
//				
				
			
				
				
				
				
				System.out.println("Qual Level: "+Double.parseDouble(requestedQualityLevel.get(timeSegReceived.size()-1).toString()));
				//Double d = (Double)qualityLevel.get(timeSegReceived.size()-1);
				System.out.println(Double.parseDouble(timeGET.get(timeSegReceived.size()-1).toString()));
				double qualityLevel= Double.parseDouble(requestedQualityLevel.get(timeSegReceived.size()-1).toString());
				double timeReceivedSegment = Double.parseDouble(timeGET.get(timeSegReceived.size()-1).toString());
				double http200OK = Double.parseDouble(HTTP200OKtime);
				
				ArrayList<Object> tcpinfo= findTCPThroughput(sublistBtwGetRequest, clientSrcPort, qualityLevel, timeForGETrequest, http200OK, indexOfTimeCompletedVideoSegmentTransmission);
				
				if(tcpinfo==null){
					//legger inn default-data 
					
					int expectedNumPAcket = qualityToNumOfPackets.get(qualityLevel);
					if(numTCPpacketsReceivedWithDefaultValues.size()>0){
						int val = Integer.parseInt(numTCPpacketsReceivedWithDefaultValues.get(numTCPpacketsReceivedWithDefaultValues.size()-1).toString());
						val+= expectedNumPAcket;
						numTCPpacketsReceivedWithDefaultValues.add(val);
					}else{
						numTCPpacketsReceivedWithDefaultValues.add(expectedNumPAcket);	
					}
					
					
					
					//TODO: fjerne sppeldata
					
					timeGET.remove(segmentThroughput.size());
					requestedQualityLevel.remove(segmentThroughput.size());
					timeSegReceived.remove(segmentThroughput.size());
					
				}else{
					
					ArrayList<Object> retransTimePackets = (ArrayList<Object>)tcpinfo.get(2);
					ArrayList<Object> qualityForRetransPackets = (ArrayList<Object>)tcpinfo.get(3);
					
					timeForRetransmittedPackets.addAll(retransTimePackets);
					qualityLevelForRetransmittedPackets.addAll(qualityForRetransPackets);
					
					
					Integer numTcpPacketsForSegment = Integer.parseInt(tcpinfo.get(1).toString());
					numTcpPackets.add(numTcpPacketsForSegment);
					segmentThroughput.add(tcpinfo.get(0));
					Double segDur = Double.parseDouble(tcpinfo.get(4).toString());
					segmentDuration.add(segDur);
					numberOfRetransmittedPacketsForSegment.add(retransTimePackets.size());
					numberOfTCPpacketsInSegment.add(numTcpPacketsForSegment);
					
					
					if(accumulatedNumTCPpacketsReceived.size()>0){
						Integer numTCP = Integer.parseInt(accumulatedNumTCPpacketsReceived.get(accumulatedNumTCPpacketsReceived.size()-1).toString())+numTcpPacketsForSegment;
						accumulatedNumTCPpacketsReceived.add(numTCP);
						
						
						
						
					}else{
						accumulatedNumTCPpacketsReceived.add(tcpinfo.get(1));
						
					}
					
					if(numTCPpacketsReceivedWithDefaultValues.size()>0){
						Integer numTCPwithDefault = Integer.parseInt(numTCPpacketsReceivedWithDefaultValues.get(numTCPpacketsReceivedWithDefaultValues.size()-1).toString())+Integer.parseInt(tcpinfo.get(1).toString());
						numTCPpacketsReceivedWithDefaultValues.add(numTCPwithDefault);
					}else{
						numTCPpacketsReceivedWithDefaultValues.add(tcpinfo.get(1));
					}
					
				}
	
//				findTCPThroughput(sublistBtwGetRequest, indexOfTimeCompletedVideoSegmentTransmission, clientSrcPort, qualityLevel, timeForGET, timeFor200OK)(sublistBtwGetRequest, indexOfTimeCompletedVideoSegmentTransmission ,clientSrcPort);
//				timeSegReceived.add(sublistBtwGetRequest.get)
//				timeSegReceived.add(timeCompletedVideoSegmentTransmission);
			}		
		}
		

		timeGET.remove(timeGET.size()-1);
		requestedQualityLevel.remove(requestedQualityLevel.size()-1);
		
		System.out.println("QualityLevelSize"+requestedQualityLevel.size());
		System.out.println("TimeForGETRequest"+timeGET.size());
		System.out.println("TimeForTCPSegmentReceived"+timeSegReceived.size());
		System.out.println("tid frste GET "+timeGET.get(0));
		System.out.println("tid for frste mottatte segment "+ timeSegReceived.get(0));
		
		System.out.println("getRequestIndexSize: "+getRequestIndex.size());
		System.out.println("TimeGetnotToAlterSize: "+timeGETNotToAlter.size());
		System.out.println("QualityLevelNotAlterSize: "+qualityLevelNotAltered.size());
		System.out.println("segmentThrougputSize: "+ segmentThroughput.size()+" "+segmentThroughput.get(0));
		System.out.println("numTCPpacketsReceivedSize: "+accumulatedNumTCPpacketsReceived.size()+" "+accumulatedNumTCPpacketsReceived.get(0));
		System.out.println("numTCPpacketsReceivedWithDefaultValues.size: "+numTCPpacketsReceivedWithDefaultValues.size());
		System.out.println("numberOfGETRequestsWithNoCorresponding200OK: "+ numberOfGETRequestsWithNoCorresponding200OK);
		System.out.println("numTcpPackets.size: "+numTcpPackets.size());
		//System.out.println("segment2sThroughputSize"+seg2sThroughput.size()+" "+seg2sThroughput.get(0));
		System.out.println("timeForRetransmittedPackets.size(): "+timeForRetransmittedPackets.size()+" lastelem: "+timeForRetransmittedPackets.get(timeForRetransmittedPackets.size()-1));
		System.out.println("qualityLevelForRetransmittedPackets.size(): "+qualityLevelForRetransmittedPackets.size()+" lastElem: "+qualityLevelForRetransmittedPackets.get(qualityLevelForRetransmittedPackets.size()-1));
		
		System.out.println("segmentDuration.size(): "+segmentDuration.size()+" last elem: "+ segmentDuration.get(segmentDuration.size()-1));
		System.out.println("numberOfRetransmittedPacketsForSegment.size(): "+numberOfRetransmittedPacketsForSegment.size()+" last elem: "+numberOfRetransmittedPacketsForSegment.get(numberOfRetransmittedPacketsForSegment.size()-1));
		System.out.println("numberOfTCPpacketsInSegment.size(): "+numberOfTCPpacketsInSegment.size()+" first: "+numberOfTCPpacketsInSegment.get(0));
		
		List<ArrayList<Object>> returnList = new ArrayList<ArrayList<Object>>(); 
		returnList.add(timeGET);
		returnList.add(timeSegReceived);
		returnList.add(requestedQualityLevel);
		returnList.add(segmentThroughput);
		returnList.add(accumulatedNumTCPpacketsReceived);
		returnList.add(qualityLevelNotAltered);
		returnList.add(timeGETNotToAlter);
		returnList.add(numTCPpacketsReceivedWithDefaultValues);
		returnList.add(numTcpPackets);
		returnList.add(timeForRetransmittedPackets);
		returnList.add(qualityLevelForRetransmittedPackets);
		returnList.add(segmentDuration);
		returnList.add(numberOfRetransmittedPacketsForSegment);
		returnList.add(numberOfTCPpacketsInSegment);
		return returnList;	
	}
	
	//returnerer en liste med ulike mter  hente ut throughput p:
	//
	//[0] - throughput for active period (double)
	//[1] - antall tcp-pakker mottatt for dette segmentet
	//[2] - ArrayList<Double> som inneholder entries med tiden for hver retransmitterte pakke, lengden av denne listen er antallet retransmitterte pakker i dette videosegmentet
	//[3] - ArrayList<Double> er i sync med [2] og inneholder kvalitetsnivet
	//[4] - Double segmentDuration
	
	
	//[1] - throughput for 2s period (double)
	//[2] - throughput for 10 og 10 pakker???
	//[3] - interarrivalBtwTCPpackets?
	private static ArrayList<Object> findTCPThroughput(List<String> sublistBtwGetRequest, String clientSrcPort, double qualityLevel, double timeForGET, double timeFor200OK, int index200OKinSublist) {	
		
		ArrayList<String> tcpPacket = new ArrayList<String>();
		ArrayList<Object> returnlist = new ArrayList<Object>();
		Double segmentDuration = timeFor200OK-timeForGET;
	
		ArrayList<Double> timeForPacketRetransmit = new ArrayList<Double>();
		ArrayList<Double> qualityLevelForRetransmittedPacket = new ArrayList<Double>();
		
		
		int expectedNumberOfTCPPackets = qualityToNumOfPackets.get(qualityLevel);
		int bytesInPacket = 1460;
		
		for(int i = 0; i< index200OKinSublist; i++){
			String [] s = sublistBtwGetRequest.get(i).split(",");
			if(s[6].contains("[TCP segment of a reassembled PDU]")&&clientSrcPort.equals(s[8])){
				tcpPacket.add(sublistBtwGetRequest.get(i));
				//if(s[6].contains("[TCP Previous segment lost]")){
				if(s[6].contains("[TCP Retransmission]")||s[6].contains("[TCP Fast Retransmission]")){
					Double time = Double.parseDouble(s[1].substring(1, s[1].length()-1));
					timeForPacketRetransmit.add(time);
					qualityLevelForRetransmittedPacket.add(qualityLevel);
				}
			}
		}
		
		
		
		
		
//		for(int i =0; i<sublistBtwGetRequest.size();i++){
//			String [] s = sublistBtwGetRequest.get(i).split(",");
//			if(s[6].contains("[TCP segment of a reassembled PDU]")&&clientSrcPort.equals(s[8])){
//				tcpPacket.add(sublistBtwGetRequest.get(i));
//
//			}
//		}
		
		 if(isWithinRange(expectedNumberOfTCPPackets, tcpPacket.size())){
			 double throughputActivePeriod = ((tcpPacket.size()*bytesInPacket*8)/(timeFor200OK-timeForGET))/1000000;
			 double throughput2sPeriod = (tcpPacket.size()*bytesInPacket*8)/2.0;
			 
			 returnlist.add(throughputActivePeriod);
			 //returnlist.add(throughput2sPeriod);
			 returnlist.add(tcpPacket.size());
//			 System.out.println("numPackets: "+tcpPacket.size());
//			 System.out.println("qualityLevel: "+qualityLevel);
//			 System.out.println("throughputActivePeriod: "+throughputActivePeriod);
//			 System.out.println("throughput2sPeriod: "+throughput2sPeriod);
//			 System.out.println("timeFor200OK-timeForGET: "+(timeFor200OK-timeForGET));
			 
			 returnlist.add(timeForPacketRetransmit);
			 returnlist.add(qualityLevelForRetransmittedPacket);
			 returnlist.add(segmentDuration);
			 
			 return returnlist;
		 }else{
			 System.out.println("WHAT? out of range, missing packets from wireshark");
			 System.out.println("number of packets: "+tcpPacket.size()+" expected: "+expectedNumberOfTCPPackets);
			 return null;
		 }
	}

	

	private static boolean isWithinRange(int expectedNumberOfTCPPackets, int numberOfPackets) {
		//20% feil godtas...(br endres?)
		double feilmargin = 0.4*expectedNumberOfTCPPackets;
		double min = expectedNumberOfTCPPackets - feilmargin;
		double max = expectedNumberOfTCPPackets + feilmargin;
		
		if(min<numberOfPackets&&numberOfPackets<max){
			return true;
		}
		
		
		return false;
	}

	//returnerer indeksen til HTTP200OK responsen, 0 hvis ingen funnet. 
	//returnerer 0.0 hvis ikke tilhrende 200OK melding funnet
	private static int findHTTP200OK(List<String> sublistBtwGetRequest,String clientSrcPort) {
		ArrayList<Double> timeFor200OK = new ArrayList<Double>();
		ArrayList<Double> timeForAudioReq = new ArrayList<Double>();
		
		ArrayList<Integer> indexFor200OK = new ArrayList<Integer>();
		
		for(int i = 0; i< sublistBtwGetRequest.size(); i++){
			String[] row = sublistBtwGetRequest.get(i).split(",");
			//System.out.println(row[6].substring(1, 14));
			if(row[6].contains("HTTP/1.1 200 OK")&&clientSrcPort.equals(row[8])){
				String s = row[1].substring(1, row[1].length()-1);
//				time200OK.put(Double.parseDouble(s), i);
				indexFor200OK.add(i);
				timeFor200OK.add(Double.parseDouble(s));
				//for sumo on tv2sumo.no:
			//}else if(row[6].contains("audio=")){
				//for live regular cap.item
			}else if(row[6].contains("track_1=")&&clientSrcPort.equals(row[7])){
				//Comoyo:
			//}else if(row[7].contains("audio_0=")&&clientSrcPort.equals(row[8])){
				//lagre tiden for audio-req, hvis 200OK meldingen kom etter en audio-req p samme port hrer den meldingen til audio
				String s = row[1].substring(1, row[1].length()-1);
//				timeAudioReq.put(Double.parseDouble(s), i);
				timeForAudioReq.add(Double.parseDouble(s));	
			}
		}
	
		if(timeForAudioReq.size()==0){
			if(timeFor200OK.size()==0||timeFor200OK.size()>1){
				System.out.println("Ingen eller for mange 200 OK req, gitt ingen audio req i subliste, 200OKSize = "+timeFor200OK.size());
				if(timeFor200OK.size()==2){
					System.out.println("1: "+timeFor200OK.get(0));
					System.out.println("2: "+timeFor200OK.get(1));
				}
				return 0;
			}
			System.out.println("Bare en 200OK som kommer fra video-req, tidspunkt: "+timeFor200OK.get(0));
			return indexFor200OK.get(0);
		}
		if(timeFor200OK.size()==0){
			System.out.println("ingen 200OK meloding registert for dette video req.");
			return 0;
		}
		//hvis 200OK meldingen kom etter en audio-req p samme port hrer den meldingen til audio
		if(timeFor200OK.get(0)>timeForAudioReq.get(0)){
			System.out.println("200OK tilhrer audio, ikke video-seg.t 200 OK: "+timeFor200OK.get(0));
			return 0;
		}else{
			System.out.println("Det er registrert flere 200OK, for dette video-seg kom meldingen inn p tiden: "+timeFor200OK.get(0));
			return indexFor200OK.get(0);
		}

		
	}
	
	//returns qualitylevel in Mbps
	private static double findQualityLevel(String GETRequest) {
		String [] split = GETRequest.split("\\(|\\)");
		//Sumo Regular Cap:
		String qualityLevel = split[1];
		//Sumo tv:
		//String qualityLevel = split[3];	
		
		
		
		double quality = Double.parseDouble(qualityLevel)/1000000;
		return quality;
	}
	
	private static List<String> readFile(String filePath) {
		String line = "";
		List<String> linesInConfigFile = new ArrayList<String>();			
	  
		try {				
			BufferedReader reader = new BufferedReader(new FileReader(filePath));
	        
			while ((line = reader.readLine()) != null){
	        	linesInConfigFile.add(line);
	        }
	        reader.close();
	       		   		        
		} catch (Exception e){
			e.printStackTrace();
			System.out.println("ERROR IN READING FILE");
		}
		return linesInConfigFile;
	}
	
	private static void createFile(ArrayList<Object> timeForGETrequest, ArrayList<Object> qualityLevel, int replicationNumber, String path) {
		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"GET+QualityR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< timeForGETrequest.size(); i++){
				  out.write(timeForGETrequest.get(i)+" "+qualityLevel.get(i)); 
				  out.newLine();
			  }
			 
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}
		
	}
	
	private static void createFile2(ArrayList<Object> timeForGETrequest, ArrayList<Object> segmentThroughput, int replicationNumber, String path) {
		try{
			  // Create file 
			  FileWriter fstream = new FileWriter(path+"GET+ThroughputR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< timeForGETrequest.size(); i++){
				  out.write(timeForGETrequest.get(i)+" "+segmentThroughput.get(i)); 
				  out.newLine();
			  }
			 
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}
		
	}
	
	private static void createFile3(ArrayList<Object> timeForGETrequest, ArrayList<Object> accumNumPackets, int replicationNumber, String path) {
		try{
			  // Create file 
			  FileWriter fstream = new FileWriter(path+"GET+accumNumPacketsR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< timeForGETrequest.size()-1; i++){
				  out.write(timeForGETrequest.get(i)+" "+accumNumPackets.get(i)); 
				  out.newLine();
			  }
			 
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}
		
	}
	private static void createFile4(ArrayList<Object> unaltGETrequetsTime, int replicationNumber, String path) {
		try{
			  // Create file 
			  FileWriter fstream = new FileWriter(path+"GETreqTimeR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< unaltGETrequetsTime.size()-1; i++){
				  out.write(unaltGETrequetsTime.get(i).toString()); 
				  out.newLine();
			  }
			 
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}
		
	}
	
	private static void createFile5(ArrayList<Object> numTcpPacketsPerSegment, int replicationNumber, String path) {
		try{
			  // Create file 
			  FileWriter fstream = new FileWriter(path+"NumTCPpacketsR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< numTcpPacketsPerSegment.size(); i++){
				  out.write(numTcpPacketsPerSegment.get(i).toString()); 
				  out.newLine();
			  }
			 
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}
		
	}
	
	private static void createFile6(ArrayList<Object> timeForRetransmittedPacket, ArrayList<Object> qualityLevelForRetransPAckets, int replicationNumber, String path) {
		try{
			  // Create file 
			  FileWriter fstream = new FileWriter(path+"TimeRetransPacketR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< timeForRetransmittedPacket.size(); i++){
				  out.write(timeForRetransmittedPacket.get(i).toString()+" "+qualityLevelForRetransPAckets.get(i).toString()); 
				  out.newLine();
			  }
			 
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}
		
	}
	
	//"statusreport"
	private static void createFile7(ArrayList<Object> qualityLevel, ArrayList<Object> timeGET, double timePLstart,  int replicationNumber, String path) {
		
		int numberOfqualityVariations = 0;
		double deltaTime;
		double timeForQualityDegradation = 0.0;
		int indexForPLstart =0;
		//perceived fairness per minute, looks better than per second?
		double perceivedFairness = 0.0;
		double sumRequestedBitrate =0.0;
		double avgRequestedBitrate = 0.0;
		
		//deltaTime 
		deltaTime = (Double.parseDouble(timeGET.get(timeGET.size()-1).toString())-timePLstart)/60.0;
		
		
		//find indexPLstart 
		for(int i =0; i < timeGET.size()-1;i++){
			double timeGETreq = Double.parseDouble(timeGET.get(i).toString());
			if(timeGETreq>timePLstart){
				indexForPLstart = i;
				break;
			}
		}
		
		//find time for qualityDegradation string
		for(int i =0; i < qualityLevel.size()-1; i++){
			double qualityLevel1 = Double.parseDouble(qualityLevel.get(i).toString());
			double qualityLevel2 = Double.parseDouble(qualityLevel.get(i+1).toString());
			if(qualityLevel1!=qualityLevel2){
				timeForQualityDegradation = Double.parseDouble(timeGET.get(i+1).toString());
				break;
			}
		}
		
		
		//find number of variations
		for(int i = indexForPLstart; i < qualityLevel.size()-1; i++){
			double qualityLevel1 = Double.parseDouble(qualityLevel.get(i).toString());
			double qualityLevel2 = Double.parseDouble(qualityLevel.get(i+1).toString());
			
			if(qualityLevel1!=qualityLevel2){
				numberOfqualityVariations++;
			}
		}
		
		//sum requested bitrate
		for(int i = indexForPLstart; i<qualityLevel.size(); i++){
			sumRequestedBitrate += Double.parseDouble(qualityLevel.get(i).toString());
		}
		
		avgRequestedBitrate = sumRequestedBitrate/(qualityLevel.size());
		
		
		perceivedFairness = numberOfqualityVariations/deltaTime;
		System.out.println("numberOfqualityVariations: "+numberOfqualityVariations);
		System.out.println("deltaTime: "+deltaTime);
		System.out.println("Perceived Fairness: "+perceivedFairness);
		System.out.println("timeForQualityDegradation: "+timeForQualityDegradation);
		System.out.println("avgRequestedBitrate: "+avgRequestedBitrate);
		
		
		try{
			  // Create file 
			  FileWriter fstream = new FileWriter(path+"SummaryR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  
			  out.write("numberOfqualityVariations: "+numberOfqualityVariations);
			  out.newLine();
			  out.write("Time from PL start to end (deltaTime) [minutes]: "+deltaTime);
			  out.newLine();
			  out.write("timeForQualityDegradation: "+timeForQualityDegradation);
			  out.newLine();
			  out.write("NumberOfQualityVariations/deltaTime: [minutes]: "+perceivedFairness);
			  out.newLine();
			  out.write("avgRequestedBitrate[Mbps]: "+avgRequestedBitrate);
			  out.newLine();
			 
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}
		
	}
	
	
	private static void createFile8(ArrayList<Object> segmentDuration, int replicationNumber, String path) {
		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"SegDurationR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< segmentDuration.size(); i++){
				  out.write(segmentDuration.get(i).toString()); 
				  out.newLine();
			  }
			 
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}
		
	}
	
	private static void createFile9(ArrayList<Object> segmentDuration, ArrayList<Object> numPL, ArrayList<Object> timeGET, int replicationNumber, String path) {
		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"NumPL+SegDuration+timeGETR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< segmentDuration.size(); i++){
				  out.write(numPL.get(i)+" "+segmentDuration.get(i).toString()+" "+timeGET.get(i)); 
				  out.newLine();
			  }
			 
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}
		
	}
	
	private static void createFile10(ArrayList<Object> segmentDuration, ArrayList<Object> numPL, int replicationNumber, String path) {
		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"NumPL+SegDurationR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< segmentDuration.size(); i++){
				  out.write(numPL.get(i)+" "+segmentDuration.get(i).toString()); 
				  out.newLine();
			  }
			 
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}
		
	}
	
	private static void createFile11(ArrayList<Object> segmentThroughput, int replicationNumber, String path) {
		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"segmentThroughputR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< segmentThroughput.size(); i++){
				  out.write(segmentThroughput.get(i).toString()); 
				  out.newLine();
			  }
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}	
	}
	
	private static void createFile12(ArrayList<Object> numRetransInSeg, ArrayList<Object> segThroughput, int replicationNumber, String path) {
		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"numRetrans+segTputR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< numRetransInSeg.size(); i++){
				  out.write(numRetransInSeg.get(i)+" "+segThroughput.get(i)); 
				  out.newLine();
			  }
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}	
	}
	
	private static void createFile13(ArrayList<Object> timeGET, ArrayList<Object> numRetransInSeg, ArrayList<Object> segDur, ArrayList<Object> tput, ArrayList<Object> numTCPpacketsInSeg,
	int replicationNumber, String path) {
		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"GETpLSegdurTputNumTCPpInSegR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  out.write("timeGET + numRetransInSeg + segDur + throughput + numTCPpacketsInSeg"); 
			  out.newLine();
			  for(int i = 0; i< numRetransInSeg.size(); i++){
				  out.write(timeGET.get(i)+" + "+numRetransInSeg.get(i)+" + "+segDur.get(i)+" + "+tput.get(i)+" + "+numTCPpacketsInSeg.get(i));
				  out.newLine();
			  }
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}	
	}
	
	private static void createFile14(ArrayList<Object> numRetransInSeg, int replicationNumber, String path) {

		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"AfterPLintroBeforeQualiDegNumRetransInSegR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< numRetransInSeg.size(); i++){
				  out.write(numRetransInSeg.get(i).toString());
				  out.newLine();
			  }
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}	
	}
	
	private static void createFile15(ArrayList<Object> numTCPpacketsInSeg, int replicationNumber, String path) {

		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"AfterPLintroBeforeQualiDegNumTCPpacketsInSegR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< numTCPpacketsInSeg.size(); i++){
				  out.write(numTCPpacketsInSeg.get(i).toString());
				  out.newLine();
			  }
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}	
	}
	
	private static void createFile16(ArrayList<Object> timeGET, int replicationNumber, String path) {

		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"AfterPLintroBeforeQualiDegTimeGETR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< timeGET.size(); i++){
				  out.write(timeGET.get(i).toString());
				  out.newLine();
			  }
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}	
	}
	
	
	private static void createFile17(ArrayList<Object> timeGET, double qualityDegradationTime, ArrayList<Double> bufferStatus, int replicationNumber, String path) {
	
		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"AfterPLintroBeforeQualiDegTimeGETandBufStatusR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< timeGET.size(); i++){
				  out.write(timeGET.get(i)+" "+bufferStatus.get(i));
				  out.newLine();
			  }
			  out.write(qualityDegradationTime+" "+bufferStatus.get(bufferStatus.size()-1));
			  out.newLine();
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}	
	}
	

	private static void createFile18(ArrayList<Object> numTCPpacketsInSegFrom30s, ArrayList<Object> numRetransInSegFrom30s, int replicationNumber, String path) {
		
		Double TCPsegs = 0.0;
		Double retransSegs =0.0;
		
		for(int i =0; i < numRetransInSegFrom30s.size(); i++){
			retransSegs+=Double.parseDouble(numRetransInSegFrom30s.get(i).toString());
			TCPsegs += Double.parseDouble(numTCPpacketsInSegFrom30s.get(i).toString());
		}
		
		Double ratio = retransSegs/TCPsegs;
		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"AfterPLintroPLratioR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  
				  out.write(ratio.toString());
				  out.newLine();
			  
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}	
	}
	private static void createFile19(ArrayList<Object> throughputFrom30s, int replicationNumber, String path) {
		
		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"AfterPLintrothroughputFrom30sR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i< throughputFrom30s.size(); i++){
				  out.write(throughputFrom30s.get(i).toString());
				  out.newLine();
			  }
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}	
	}
	
	private static void createFile20(ArrayList<Object> numTCPpacketsInSegFrom30s, ArrayList<Object> numRetransInSegFrom30s, ArrayList<Object> throughputInSegFrom30s,  int replicationNumber, String path) {
		
		ArrayList<Double> segPLratio = new ArrayList<Double>();
		for(int i = 0; i < numTCPpacketsInSegFrom30s.size(); i++){
			double TCPpackets = Double.parseDouble(numTCPpacketsInSegFrom30s.get(i).toString());
			double numRetrans = Double.parseDouble(numRetransInSegFrom30s.get(i).toString());
			double ratio = numRetrans/TCPpackets;
			segPLratio.add(ratio);
		}
		
		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"AfterPLintroPLratio+TputR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i < segPLratio.size(); i++){
				  out.write(segPLratio.get(i)+" "+throughputInSegFrom30s.get(i));
				  out.newLine();				  
			  }
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}	
	}
	
	private static void createFile21(ArrayList<Object> throughputAfterPLintroBeforeQLd, int replicationNumber, String path) {
		
		try{
			  // Create file 
			  //C:\Users\shuna\Dropbox\Master\Mathematica\Mlinger\Blue sky\The shit\Sumo\No packet loss
			  FileWriter fstream = new FileWriter(path+"AfterPLintroBeforeQualiDegthroughputR"+replicationNumber+".txt");
			  BufferedWriter out = new BufferedWriter(fstream);
			  for(int i = 0; i < throughputAfterPLintroBeforeQLd.size(); i++){
				  out.write(throughputAfterPLintroBeforeQLd.get(i).toString());
				  out.newLine();				  
			  }
			  //Close the output stream
			  out.close();
		}catch (Exception e){//Catch exception if any
			  System.err.println("Error: " + e.getMessage());
		}	
	}
	
}
